{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# HW 2 Part 2\n",
    "\n",
    "By: Chengyi (Jeff) Chen"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "/opt/anaconda3/envs/ml/lib/python3.7/site-packages/statsmodels/tools/_testing.py:19: FutureWarning: pandas.util.testing is deprecated. Use the functions in the public API at pandas.testing instead.\n",
      "  import pandas.util.testing as tm\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 1;\n",
       "                var nbb_unformatted_code = \"%load_ext autotime\\n%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom collections import namedtuple\\nfrom statsmodels.graphics.gofplots import qqplot\\nfrom datetime import datetime, timedelta\\nfrom tqdm import tqdm\";\n",
       "                var nbb_formatted_code = \"%load_ext autotime\\n%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom collections import namedtuple\\nfrom statsmodels.graphics.gofplots import qqplot\\nfrom datetime import datetime, timedelta\\nfrom tqdm import tqdm\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%load_ext autotime\n",
    "%load_ext nb_black\n",
    "%matplotlib inline\n",
    "\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "plt.rcParams[\"figure.dpi\"] = 300\n",
    "plt.rcParams[\"figure.figsize\"] = (16, 12)\n",
    "\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "import cvxpy as cp\n",
    "import scipy as sp\n",
    "from collections import namedtuple\n",
    "from statsmodels.graphics.gofplots import qqplot\n",
    "from datetime import datetime, timedelta\n",
    "from tqdm import tqdm"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### SPY and US Dollar Index Monthly Returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>S&amp;P - 500 Index</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-0.984416</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-6.260163</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-8.075231</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>1.906875</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>7.670629</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            S&P - 500 Index\n",
       "2001-07-31        -0.984416\n",
       "2001-08-31        -6.260163\n",
       "2001-09-30        -8.075231\n",
       "2001-10-31         1.906875\n",
       "2001-11-30         7.670629"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 872 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 2;\n",
       "                var nbb_unformatted_code = \"spy_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\\n)\\nspy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\\nspy_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"spy_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\\n)\\nspy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\\nspy_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "spy_monthly_returns = pd.read_excel(\n",
    "    \"./data/HW2.xlsx\", sheet_name=2, usecols=[0, 1], header=[0], index_col=[0]\n",
    ")\n",
    "spy_monthly_returns.index = pd.to_datetime(spy_monthly_returns.index)\n",
    "spy_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>US Dollar Index</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-1.916799</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-3.208739</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-0.008817</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>1.278547</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>1.105694</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            US Dollar Index\n",
       "2001-07-31        -1.916799\n",
       "2001-08-31        -3.208739\n",
       "2001-09-30        -0.008817\n",
       "2001-10-31         1.278547\n",
       "2001-11-30         1.105694"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 855 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 3;\n",
       "                var nbb_unformatted_code = \"us_dollar_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\\n)\\nus_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\\nus_dollar_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"us_dollar_monthly_returns = pd.read_excel(\\n    \\\"./data/HW2.xlsx\\\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\\n)\\nus_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\\nus_dollar_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "us_dollar_monthly_returns = pd.read_excel(\n",
    "    \"./data/HW2.xlsx\", sheet_name=2, usecols=[0, 2], header=[0], index_col=[0]\n",
    ")\n",
    "us_dollar_monthly_returns.index = pd.to_datetime(us_dollar_monthly_returns.index)\n",
    "us_dollar_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "#### S&P 500 Equities Monthly Returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead tr th {\n",
       "        text-align: left;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr>\n",
       "      <th>NAME</th>\n",
       "      <th>3m Co</th>\n",
       "      <th>Abbott Labs</th>\n",
       "      <th>Abbvie Inc</th>\n",
       "      <th>Abiomed Inc</th>\n",
       "      <th>Accenture Plc Ireland</th>\n",
       "      <th>Activision Blizzard Inc</th>\n",
       "      <th>Adobe Sys Inc</th>\n",
       "      <th>Advance Auto Parts</th>\n",
       "      <th>Advanced Micro Devic</th>\n",
       "      <th>Aes Corp</th>\n",
       "      <th>...</th>\n",
       "      <th>Willis Towers Watson Pu</th>\n",
       "      <th>Wynn Resorts Ltd</th>\n",
       "      <th>Xcel Energy Inc</th>\n",
       "      <th>Xerox Corp</th>\n",
       "      <th>Xilinx Inc</th>\n",
       "      <th>Xylem Inc</th>\n",
       "      <th>Yum Brands Inc</th>\n",
       "      <th>Zimmer Hldgs Inc</th>\n",
       "      <th>Zions Bancorp</th>\n",
       "      <th>Zoetis Inc</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>TICKER</th>\n",
       "      <th>MMM</th>\n",
       "      <th>ABT</th>\n",
       "      <th>ABBV</th>\n",
       "      <th>ABMD</th>\n",
       "      <th>ACN</th>\n",
       "      <th>ATVI</th>\n",
       "      <th>ADBE</th>\n",
       "      <th>AAP</th>\n",
       "      <th>AMD</th>\n",
       "      <th>AES</th>\n",
       "      <th>...</th>\n",
       "      <th>WLTW</th>\n",
       "      <th>WYNN</th>\n",
       "      <th>XEL</th>\n",
       "      <th>XRX</th>\n",
       "      <th>XLNX</th>\n",
       "      <th>XYL</th>\n",
       "      <th>YUM</th>\n",
       "      <th>ZBH</th>\n",
       "      <th>ZION</th>\n",
       "      <th>ZTS</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR</th>\n",
       "      <th>INDU</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>INFT</th>\n",
       "      <th>TCOM</th>\n",
       "      <th>INFT</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>INFT</th>\n",
       "      <th>UTIL</th>\n",
       "      <th>...</th>\n",
       "      <th>FINA</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>UTIL</th>\n",
       "      <th>INFT</th>\n",
       "      <th>INFT</th>\n",
       "      <th>INDU</th>\n",
       "      <th>DSCR</th>\n",
       "      <th>HLTH</th>\n",
       "      <th>FINA</th>\n",
       "      <th>HLTH</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>Market Cap ($ Mil)</th>\n",
       "      <th>110949</th>\n",
       "      <th>127036</th>\n",
       "      <th>138674</th>\n",
       "      <th>14640</th>\n",
       "      <th>89887</th>\n",
       "      <th>35535</th>\n",
       "      <th>110435</th>\n",
       "      <th>11478</th>\n",
       "      <th>18449</th>\n",
       "      <th>9577</th>\n",
       "      <th>...</th>\n",
       "      <th>19733</th>\n",
       "      <th>10755</th>\n",
       "      <th>25326</th>\n",
       "      <th>4708</th>\n",
       "      <th>21552</th>\n",
       "      <th>11991</th>\n",
       "      <th>28707</th>\n",
       "      <th>21156</th>\n",
       "      <th>7830</th>\n",
       "      <th>41098</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-1.945100</td>\n",
       "      <td>12.112976</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-19.423240</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-13.577718</td>\n",
       "      <td>-20.234087</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-36.816609</td>\n",
       "      <td>-11.033682</td>\n",
       "      <td>...</td>\n",
       "      <td>-2.816904</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-4.077114</td>\n",
       "      <td>-16.614480</td>\n",
       "      <td>-3.006790</td>\n",
       "      <td>NaN</td>\n",
       "      <td>4.214608</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-0.932129</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-6.446533</td>\n",
       "      <td>-7.258951</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-1.315789</td>\n",
       "      <td>-0.401070</td>\n",
       "      <td>9.226306</td>\n",
       "      <td>-10.349165</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-25.794085</td>\n",
       "      <td>-13.524804</td>\n",
       "      <td>...</td>\n",
       "      <td>9.043619</td>\n",
       "      <td>NaN</td>\n",
       "      <td>1.707327</td>\n",
       "      <td>15.288163</td>\n",
       "      <td>-2.400000</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.842003</td>\n",
       "      <td>-4.895105</td>\n",
       "      <td>-1.698511</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-5.475902</td>\n",
       "      <td>4.326061</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.826667</td>\n",
       "      <td>-14.429530</td>\n",
       "      <td>-26.532794</td>\n",
       "      <td>-28.616782</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-39.852399</td>\n",
       "      <td>-61.292271</td>\n",
       "      <td>...</td>\n",
       "      <td>24.348706</td>\n",
       "      <td>NaN</td>\n",
       "      <td>4.106134</td>\n",
       "      <td>-15.760939</td>\n",
       "      <td>-39.728484</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-7.977550</td>\n",
       "      <td>2.022059</td>\n",
       "      <td>-6.287271</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>6.077282</td>\n",
       "      <td>2.599966</td>\n",
       "      <td>NaN</td>\n",
       "      <td>24.441900</td>\n",
       "      <td>37.803922</td>\n",
       "      <td>32.808711</td>\n",
       "      <td>10.091781</td>\n",
       "      <td>NaN</td>\n",
       "      <td>20.736196</td>\n",
       "      <td>8.034321</td>\n",
       "      <td>...</td>\n",
       "      <td>-0.427533</td>\n",
       "      <td>NaN</td>\n",
       "      <td>0.461629</td>\n",
       "      <td>-9.677419</td>\n",
       "      <td>29.281768</td>\n",
       "      <td>NaN</td>\n",
       "      <td>28.990256</td>\n",
       "      <td>11.387387</td>\n",
       "      <td>-10.696854</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>10.339559</td>\n",
       "      <td>3.812730</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-12.741490</td>\n",
       "      <td>28.628344</td>\n",
       "      <td>3.113693</td>\n",
       "      <td>21.515301</td>\n",
       "      <td>NaN</td>\n",
       "      <td>37.804878</td>\n",
       "      <td>19.277978</td>\n",
       "      <td>...</td>\n",
       "      <td>1.674522</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-3.429815</td>\n",
       "      <td>20.000215</td>\n",
       "      <td>18.704799</td>\n",
       "      <td>NaN</td>\n",
       "      <td>-6.206153</td>\n",
       "      <td>4.367519</td>\n",
       "      <td>1.164570</td>\n",
       "      <td>NaN</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>5 rows × 505 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "NAME                    3m Co Abbott Labs Abbvie Inc Abiomed Inc  \\\n",
       "TICKER                    MMM         ABT       ABBV        ABMD   \n",
       "SECTOR                   INDU        HLTH       HLTH        HLTH   \n",
       "Market Cap ($ Mil)     110949      127036     138674      14640    \n",
       "2001-07-31          -1.945100   12.112976        NaN  -19.423240   \n",
       "2001-08-31          -6.446533   -7.258951        NaN   -1.315789   \n",
       "2001-09-30          -5.475902    4.326061        NaN   -6.826667   \n",
       "2001-10-31           6.077282    2.599966        NaN   24.441900   \n",
       "2001-11-30          10.339559    3.812730        NaN  -12.741490   \n",
       "\n",
       "NAME               Accenture Plc Ireland Activision Blizzard Inc  \\\n",
       "TICKER                               ACN                    ATVI   \n",
       "SECTOR                              INFT                    TCOM   \n",
       "Market Cap ($ Mil)                89887                   35535    \n",
       "2001-07-31                           NaN              -13.577718   \n",
       "2001-08-31                     -0.401070                9.226306   \n",
       "2001-09-30                    -14.429530              -26.532794   \n",
       "2001-10-31                     37.803922               32.808711   \n",
       "2001-11-30                     28.628344                3.113693   \n",
       "\n",
       "NAME               Adobe Sys Inc Advance Auto Parts Advanced Micro Devic  \\\n",
       "TICKER                      ADBE                AAP                  AMD   \n",
       "SECTOR                      INFT               DSCR                 INFT   \n",
       "Market Cap ($ Mil)        110435             11478                18449    \n",
       "2001-07-31            -20.234087                NaN           -36.816609   \n",
       "2001-08-31            -10.349165                NaN           -25.794085   \n",
       "2001-09-30            -28.616782                NaN           -39.852399   \n",
       "2001-10-31             10.091781                NaN            20.736196   \n",
       "2001-11-30             21.515301                NaN            37.804878   \n",
       "\n",
       "NAME                 Aes Corp  ... Willis Towers Watson Pu Wynn Resorts Ltd  \\\n",
       "TICKER                    AES  ...                    WLTW             WYNN   \n",
       "SECTOR                   UTIL  ...                    FINA             DSCR   \n",
       "Market Cap ($ Mil)     9577    ...                  19733            10755    \n",
       "2001-07-31         -11.033682  ...               -2.816904              NaN   \n",
       "2001-08-31         -13.524804  ...                9.043619              NaN   \n",
       "2001-09-30         -61.292271  ...               24.348706              NaN   \n",
       "2001-10-31           8.034321  ...               -0.427533              NaN   \n",
       "2001-11-30          19.277978  ...                1.674522              NaN   \n",
       "\n",
       "NAME               Xcel Energy Inc Xerox Corp Xilinx Inc Xylem Inc  \\\n",
       "TICKER                         XEL        XRX       XLNX       XYL   \n",
       "SECTOR                        UTIL       INFT       INFT      INDU   \n",
       "Market Cap ($ Mil)          25326      4708       21552     11991    \n",
       "2001-07-31               -4.077114 -16.614480  -3.006790       NaN   \n",
       "2001-08-31                1.707327  15.288163  -2.400000       NaN   \n",
       "2001-09-30                4.106134 -15.760939 -39.728484       NaN   \n",
       "2001-10-31                0.461629  -9.677419  29.281768       NaN   \n",
       "2001-11-30               -3.429815  20.000215  18.704799       NaN   \n",
       "\n",
       "NAME               Yum Brands Inc Zimmer Hldgs Inc Zions Bancorp Zoetis Inc  \n",
       "TICKER                        YUM              ZBH          ZION        ZTS  \n",
       "SECTOR                       DSCR             HLTH          FINA       HLTH  \n",
       "Market Cap ($ Mil)         28707            21156         7830       41098   \n",
       "2001-07-31               4.214608              NaN     -0.932129        NaN  \n",
       "2001-08-31              -6.842003        -4.895105     -1.698511        NaN  \n",
       "2001-09-30              -7.977550         2.022059     -6.287271        NaN  \n",
       "2001-10-31              28.990256        11.387387    -10.696854        NaN  \n",
       "2001-11-30              -6.206153         4.367519      1.164570        NaN  \n",
       "\n",
       "[5 rows x 505 columns]"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 1.9 s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 4;\n",
       "                var nbb_unformatted_code = \"equity_monthly_returns = (\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1]).iloc[:, 4:].T\\n)\\nequity_monthly_returns.columns = pd.MultiIndex.from_frame(\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\\n)\\nequity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\\nequity_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"equity_monthly_returns = (\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1]).iloc[:, 4:].T\\n)\\nequity_monthly_returns.columns = pd.MultiIndex.from_frame(\\n    pd.read_excel(\\\"./data/HW2.xlsx\\\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\\n)\\nequity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\\nequity_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "equity_monthly_returns = (\n",
    "    pd.read_excel(\"./data/HW2.xlsx\", sheet_name=1, header=[1]).iloc[:, 4:].T\n",
    ")\n",
    "equity_monthly_returns.columns = pd.MultiIndex.from_frame(\n",
    "    pd.read_excel(\"./data/HW2.xlsx\", sheet_name=1, header=[1], usecols=[0, 1, 2, 3])\n",
    ")\n",
    "equity_monthly_returns.index = pd.to_datetime(equity_monthly_returns.index)\n",
    "equity_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>β (equity market factor exposure)</th>\n",
       "      <th>β (us dollar factor exposure)</th>\n",
       "      <th>SECTOR_DSCR</th>\n",
       "      <th>SECTOR_ENER</th>\n",
       "      <th>SECTOR_FINA</th>\n",
       "      <th>SECTOR_HLTH</th>\n",
       "      <th>SECTOR_INDU</th>\n",
       "      <th>SECTOR_INFT</th>\n",
       "      <th>SECTOR_MATS</th>\n",
       "      <th>SECTOR_REAL</th>\n",
       "      <th>SECTOR_STPL</th>\n",
       "      <th>SECTOR_TCOM</th>\n",
       "      <th>β (size factor exposure)</th>\n",
       "      <th>γ_residual</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2001-07-31</th>\n",
       "      <td>-5.081906</td>\n",
       "      <td>0.546521</td>\n",
       "      <td>9.689164</td>\n",
       "      <td>4.497985</td>\n",
       "      <td>6.003830</td>\n",
       "      <td>3.868261</td>\n",
       "      <td>7.997561</td>\n",
       "      <td>5.971431</td>\n",
       "      <td>7.795002</td>\n",
       "      <td>3.298414</td>\n",
       "      <td>5.834931</td>\n",
       "      <td>4.522445</td>\n",
       "      <td>-0.666501</td>\n",
       "      <td>-0.172946</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-08-31</th>\n",
       "      <td>-5.351213</td>\n",
       "      <td>-2.530621</td>\n",
       "      <td>-0.865683</td>\n",
       "      <td>-1.974351</td>\n",
       "      <td>-0.172676</td>\n",
       "      <td>0.152704</td>\n",
       "      <td>0.283117</td>\n",
       "      <td>-0.786473</td>\n",
       "      <td>2.069103</td>\n",
       "      <td>2.237107</td>\n",
       "      <td>0.399686</td>\n",
       "      <td>-0.210663</td>\n",
       "      <td>-0.887846</td>\n",
       "      <td>3.563947</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-09-30</th>\n",
       "      <td>-16.448408</td>\n",
       "      <td>-4.242000</td>\n",
       "      <td>6.115425</td>\n",
       "      <td>5.129572</td>\n",
       "      <td>15.719172</td>\n",
       "      <td>7.981975</td>\n",
       "      <td>9.199334</td>\n",
       "      <td>8.180248</td>\n",
       "      <td>9.807025</td>\n",
       "      <td>11.983056</td>\n",
       "      <td>5.616929</td>\n",
       "      <td>8.494224</td>\n",
       "      <td>-0.404314</td>\n",
       "      <td>0.634008</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-10-31</th>\n",
       "      <td>7.730491</td>\n",
       "      <td>4.661245</td>\n",
       "      <td>-0.237472</td>\n",
       "      <td>5.161065</td>\n",
       "      <td>-8.600545</td>\n",
       "      <td>2.401637</td>\n",
       "      <td>-3.667805</td>\n",
       "      <td>5.580222</td>\n",
       "      <td>-2.020707</td>\n",
       "      <td>-6.257782</td>\n",
       "      <td>-0.408720</td>\n",
       "      <td>0.168053</td>\n",
       "      <td>-0.612423</td>\n",
       "      <td>-2.110206</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2001-11-30</th>\n",
       "      <td>9.140003</td>\n",
       "      <td>4.696506</td>\n",
       "      <td>3.084856</td>\n",
       "      <td>-7.999442</td>\n",
       "      <td>-0.934668</td>\n",
       "      <td>0.446165</td>\n",
       "      <td>1.300240</td>\n",
       "      <td>2.209795</td>\n",
       "      <td>3.643307</td>\n",
       "      <td>-0.218926</td>\n",
       "      <td>2.664973</td>\n",
       "      <td>-1.297612</td>\n",
       "      <td>1.092705</td>\n",
       "      <td>-3.667960</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            β (equity market factor exposure)  β (us dollar factor exposure)  \\\n",
       "2001-07-31                          -5.081906                       0.546521   \n",
       "2001-08-31                          -5.351213                      -2.530621   \n",
       "2001-09-30                         -16.448408                      -4.242000   \n",
       "2001-10-31                           7.730491                       4.661245   \n",
       "2001-11-30                           9.140003                       4.696506   \n",
       "\n",
       "            SECTOR_DSCR  SECTOR_ENER  SECTOR_FINA  SECTOR_HLTH  SECTOR_INDU  \\\n",
       "2001-07-31     9.689164     4.497985     6.003830     3.868261     7.997561   \n",
       "2001-08-31    -0.865683    -1.974351    -0.172676     0.152704     0.283117   \n",
       "2001-09-30     6.115425     5.129572    15.719172     7.981975     9.199334   \n",
       "2001-10-31    -0.237472     5.161065    -8.600545     2.401637    -3.667805   \n",
       "2001-11-30     3.084856    -7.999442    -0.934668     0.446165     1.300240   \n",
       "\n",
       "            SECTOR_INFT  SECTOR_MATS  SECTOR_REAL  SECTOR_STPL  SECTOR_TCOM  \\\n",
       "2001-07-31     5.971431     7.795002     3.298414     5.834931     4.522445   \n",
       "2001-08-31    -0.786473     2.069103     2.237107     0.399686    -0.210663   \n",
       "2001-09-30     8.180248     9.807025    11.983056     5.616929     8.494224   \n",
       "2001-10-31     5.580222    -2.020707    -6.257782    -0.408720     0.168053   \n",
       "2001-11-30     2.209795     3.643307    -0.218926     2.664973    -1.297612   \n",
       "\n",
       "            β (size factor exposure)  γ_residual  \n",
       "2001-07-31                 -0.666501   -0.172946  \n",
       "2001-08-31                 -0.887846    3.563947  \n",
       "2001-09-30                 -0.404314    0.634008  \n",
       "2001-10-31                 -0.612423   -2.110206  \n",
       "2001-11-30                  1.092705   -3.667960  "
      ]
     },
     "execution_count": 5,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 4.07 s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 5;\n",
       "                var nbb_unformatted_code = \"intersect = lambda a, b: sorted(set(a) & set(b))\\n\\n\\ndef \\u03b2_hat(X, y, dropna=True):\\n    if dropna:\\n        X, y = X.dropna(), y.dropna()\\n        common_index = intersect(X.index, y.index)\\n        X, y = X.loc[common_index], y.loc[common_index]\\n    else:\\n        X, y = X.fillna(0.0), y.fillna(0.0)\\n    return (\\n        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\\n        @ X.T\\n        @ y.values\\n    )\\n\\n\\n# Factor Exposures to SPY and US Dollar\\nfactor_exposures = equity_monthly_returns.apply(\\n    lambda equity: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                spy_monthly_returns,\\n                us_dollar_monthly_returns,\\n                pd.Series(1, name=\\\"\\u03b1\\\", index=spy_monthly_returns.index),\\n            ],\\n            axis=1,\\n        ),\\n        y=equity,\\n        dropna=True,\\n    ),\\n    axis=0,\\n).T\\nfactor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\\nfactor_exposures.rename(\\n    {\\n        \\\"S&P - 500 Index\\\": \\\"\\u03b2 (equity market factor exposure)\\\",\\n        \\\"US Dollar Index\\\": \\\"\\u03b2 (us dollar factor exposure)\\\",\\n    },\\n    axis=1,\\n    inplace=True,\\n)\\n\\n# Sector Exposure\\nsector_factor = pd.concat(\\n    [\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n    ],\\n    axis=1,\\n)\\nsector_factor.set_index(\\\"NAME\\\", inplace=True)\\nsector_factor = pd.get_dummies(sector_factor).drop([\\\"SECTOR_UTIL\\\"], axis=1)\\n\\n# Size Exposure\\nsize_factor = (\\n    pd.concat(\\n        [\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n            pd.Series(\\n                equity_monthly_returns.columns.get_level_values(\\\"Market Cap ($ Mil)\\\")\\n            ),\\n        ],\\n        axis=1,\\n    )\\n    .groupby(\\\"SECTOR\\\")[\\\"Market Cap ($ Mil)\\\"]\\n    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\\n    .to_frame()\\n)\\nsize_factor.index = equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")\\nsize_factor.rename(\\n    {\\\"Market Cap ($ Mil)\\\": \\\"\\u03b2 (size factor exposure)\\\"}, axis=1, inplace=True\\n)\\n\\n# Pure Monthly Returns of each factor\\n\\u03b3_pure_factor_monthly_returns = equity_monthly_returns.apply(\\n    lambda returns: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n                sector_factor,\\n                size_factor,\\n                pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n            ],\\n            axis=1,\\n        ),\\n        y=returns,\\n        dropna=False,\\n    ),\\n    axis=1,\\n)\\n\\u03b3_pure_factor_monthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"intersect = lambda a, b: sorted(set(a) & set(b))\\n\\n\\ndef \\u03b2_hat(X, y, dropna=True):\\n    if dropna:\\n        X, y = X.dropna(), y.dropna()\\n        common_index = intersect(X.index, y.index)\\n        X, y = X.loc[common_index], y.loc[common_index]\\n    else:\\n        X, y = X.fillna(0.0), y.fillna(0.0)\\n    return (\\n        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\\n        @ X.T\\n        @ y.values\\n    )\\n\\n\\n# Factor Exposures to SPY and US Dollar\\nfactor_exposures = equity_monthly_returns.apply(\\n    lambda equity: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                spy_monthly_returns,\\n                us_dollar_monthly_returns,\\n                pd.Series(1, name=\\\"\\u03b1\\\", index=spy_monthly_returns.index),\\n            ],\\n            axis=1,\\n        ),\\n        y=equity,\\n        dropna=True,\\n    ),\\n    axis=0,\\n).T\\nfactor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\\nfactor_exposures.rename(\\n    {\\n        \\\"S&P - 500 Index\\\": \\\"\\u03b2 (equity market factor exposure)\\\",\\n        \\\"US Dollar Index\\\": \\\"\\u03b2 (us dollar factor exposure)\\\",\\n    },\\n    axis=1,\\n    inplace=True,\\n)\\n\\n# Sector Exposure\\nsector_factor = pd.concat(\\n    [\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n        pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n    ],\\n    axis=1,\\n)\\nsector_factor.set_index(\\\"NAME\\\", inplace=True)\\nsector_factor = pd.get_dummies(sector_factor).drop([\\\"SECTOR_UTIL\\\"], axis=1)\\n\\n# Size Exposure\\nsize_factor = (\\n    pd.concat(\\n        [\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")),\\n            pd.Series(equity_monthly_returns.columns.get_level_values(\\\"SECTOR\\\")),\\n            pd.Series(\\n                equity_monthly_returns.columns.get_level_values(\\\"Market Cap ($ Mil)\\\")\\n            ),\\n        ],\\n        axis=1,\\n    )\\n    .groupby(\\\"SECTOR\\\")[\\\"Market Cap ($ Mil)\\\"]\\n    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\\n    .to_frame()\\n)\\nsize_factor.index = equity_monthly_returns.columns.get_level_values(\\\"NAME\\\")\\nsize_factor.rename(\\n    {\\\"Market Cap ($ Mil)\\\": \\\"\\u03b2 (size factor exposure)\\\"}, axis=1, inplace=True\\n)\\n\\n# Pure Monthly Returns of each factor\\n\\u03b3_pure_factor_monthly_returns = equity_monthly_returns.apply(\\n    lambda returns: \\u03b2_hat(\\n        X=pd.concat(\\n            [\\n                factor_exposures.drop([\\\"\\u03b1\\\"], axis=1),\\n                sector_factor,\\n                size_factor,\\n                pd.Series(1, index=size_factor.index, name=\\\"\\u03b3_residual\\\"),\\n            ],\\n            axis=1,\\n        ),\\n        y=returns,\\n        dropna=False,\\n    ),\\n    axis=1,\\n)\\n\\u03b3_pure_factor_monthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "intersect = lambda a, b: sorted(set(a) & set(b))\n",
    "\n",
    "\n",
    "def β_hat(X, y, dropna=True):\n",
    "    if dropna:\n",
    "        X, y = X.dropna(), y.dropna()\n",
    "        common_index = intersect(X.index, y.index)\n",
    "        X, y = X.loc[common_index], y.loc[common_index]\n",
    "    else:\n",
    "        X, y = X.fillna(0.0), y.fillna(0.0)\n",
    "    return (\n",
    "        pd.DataFrame(np.linalg.inv(X.T @ X), columns=X.columns, index=X.columns)\n",
    "        @ X.T\n",
    "        @ y.values\n",
    "    )\n",
    "\n",
    "\n",
    "# Factor Exposures to SPY and US Dollar\n",
    "factor_exposures = equity_monthly_returns.apply(\n",
    "    lambda equity: β_hat(\n",
    "        X=pd.concat(\n",
    "            [\n",
    "                spy_monthly_returns,\n",
    "                us_dollar_monthly_returns,\n",
    "                pd.Series(1, name=\"α\", index=spy_monthly_returns.index),\n",
    "            ],\n",
    "            axis=1,\n",
    "        ),\n",
    "        y=equity,\n",
    "        dropna=True,\n",
    "    ),\n",
    "    axis=0,\n",
    ").T\n",
    "factor_exposures.reset_index(level=[1, 2, 3], drop=True, inplace=True)\n",
    "factor_exposures.rename(\n",
    "    {\n",
    "        \"S&P - 500 Index\": \"β (equity market factor exposure)\",\n",
    "        \"US Dollar Index\": \"β (us dollar factor exposure)\",\n",
    "    },\n",
    "    axis=1,\n",
    "    inplace=True,\n",
    ")\n",
    "\n",
    "# Sector Exposure\n",
    "sector_factor = pd.concat(\n",
    "    [\n",
    "        pd.Series(equity_monthly_returns.columns.get_level_values(\"NAME\")),\n",
    "        pd.Series(equity_monthly_returns.columns.get_level_values(\"SECTOR\")),\n",
    "    ],\n",
    "    axis=1,\n",
    ")\n",
    "sector_factor.set_index(\"NAME\", inplace=True)\n",
    "sector_factor = pd.get_dummies(sector_factor).drop([\"SECTOR_UTIL\"], axis=1)\n",
    "\n",
    "# Size Exposure\n",
    "size_factor = (\n",
    "    pd.concat(\n",
    "        [\n",
    "            pd.Series(equity_monthly_returns.columns.get_level_values(\"NAME\")),\n",
    "            pd.Series(equity_monthly_returns.columns.get_level_values(\"SECTOR\")),\n",
    "            pd.Series(\n",
    "                equity_monthly_returns.columns.get_level_values(\"Market Cap ($ Mil)\")\n",
    "            ),\n",
    "        ],\n",
    "        axis=1,\n",
    "    )\n",
    "    .groupby(\"SECTOR\")[\"Market Cap ($ Mil)\"]\n",
    "    .transform(lambda x: (np.log(x) - np.log(x).mean()) / np.log(x).std())\n",
    "    .to_frame()\n",
    ")\n",
    "size_factor.index = equity_monthly_returns.columns.get_level_values(\"NAME\")\n",
    "size_factor.rename(\n",
    "    {\"Market Cap ($ Mil)\": \"β (size factor exposure)\"}, axis=1, inplace=True\n",
    ")\n",
    "\n",
    "# Pure Monthly Returns of each factor\n",
    "γ_pure_factor_monthly_returns = equity_monthly_returns.apply(\n",
    "    lambda returns: β_hat(\n",
    "        X=pd.concat(\n",
    "            [\n",
    "                factor_exposures.drop([\"α\"], axis=1),\n",
    "                sector_factor,\n",
    "                size_factor,\n",
    "                pd.Series(1, index=size_factor.index, name=\"γ_residual\"),\n",
    "            ],\n",
    "            axis=1,\n",
    "        ),\n",
    "        y=returns,\n",
    "        dropna=False,\n",
    "    ),\n",
    "    axis=1,\n",
    ")\n",
    "γ_pure_factor_monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## Problems"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Black Litterman Model"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Preliminaries"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "From HW2 Part 1, you have located 10 sector factor returns, i.e., 10 monthly return time series. Let's practise Black-Litterman model with the following assumptions:\n",
    "\n",
    "1. For the 10 sector factors, equlibrium expected monthly returns $\\Pi$ are assumed to equal historical average monthly returns. \n",
    "\n",
    "2. Using historical monthly return covariance matrix $\\Sigma$\n",
    "\n",
    "3. Uncertainty metric $\\tau$ for the prior distribution of the factor expected returns equals 0.05.\n",
    "\n",
    "4. Assuming we have the views as follows:\n",
    "\n",
    "    - View 1: Sector ENER will have return of 0.20% in next month.\n",
    "    \n",
    "    - View 2: Sector FINA will outperform Sector INDU by 0.05% in next month.\n",
    "    \n",
    "    - View 3: Sector INFT and Sector HLTH will outperform Sector REAL and Sector STPL by 0.30% in next month. (Assuming equal weighting on both long and short legs)\n",
    "\n",
    "5. Assuming view uncertainty for each view portfolio equals the historical variance of each view portfolio. ($\\Omega=\\tau P \\Sigma P^\\top$)."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 9.5 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 6;\n",
       "                var nbb_unformatted_code = \"\\u03b4_eq = lambda R_mkt, R_f, \\u03c3_mkt: (R_mkt - R_f) / (\\u03c3_mkt ** 2)  # Risk Aversion measure\\n\\u03a0 = lambda \\u03b4_eq, \\u03a3, w_eq: \\u03b4_eq * (\\u03a3 @ w_eq)  # Equilibrium Excess Return vector\\nC = lambda \\u03c4, \\u03a3: \\u03c4 * \\u03a3  # Covariance matrix for Prior Normal\\nH = lambda P, \\u03a9, C: (P.T @ np.linalg.inv(\\u03a9)) @ P + np.linalg.inv(\\n    C\\n)  # Precision Matrix of Posterior Normal\\n\\u03bd = lambda H, P, \\u03a9, Q, C, \\u03a0: np.linalg.inv(H) @ (\\n    (P.T @ np.linalg.inv(\\u03a9)) @ Q + np.linalg.inv(C) @ \\u03a0\\n)  # Mean of Posterior Normal\\n\\n\\u03bc = \\u03b3_pure_factor_monthly_returns[sector_factor.columns].mean()\\n\\u03a0 = \\u03bc  # 1. Arithmetic Historical average of monthly returns (N x 1)\\n\\u03a3 = \\u03b3_pure_factor_monthly_returns[\\n    sector_factor.columns\\n].cov()  # 2. Historical monthly covariance matrix (N x N)\\n\\u03c4 = 0.05  # 3. Uncertainty metric for prior distribution of \\u03b8's covariance matrix\\n\\nP = pd.DataFrame(\\n    np.zeros((3, len(sector_factor.columns))),\\n    index=[\\\"view 1\\\", \\\"view 2\\\", \\\"view 3\\\"],\\n    columns=sector_factor.columns,\\n)  # View Portfolio Matrix (k x N)\\nQ = pd.DataFrame(\\n    np.zeros((3, 1)), index=[\\\"view 1\\\", \\\"view 2\\\", \\\"view 3\\\"], columns=[\\\"expected return\\\"]\\n)  # View Expected Return Vector (k x 1)\\n\\n# Active View 1\\nP.loc[\\\"view 1\\\"][\\\"SECTOR_ENER\\\"] = 1\\nQ.loc[\\\"view 1\\\"][\\\"expected return\\\"] = 0.2\\n\\n# Active View 2\\nP.loc[\\\"view 2\\\"][\\\"SECTOR_FINA\\\"], P.loc[\\\"view 2\\\"][\\\"SECTOR_INDU\\\"] = 1, -1\\nQ.loc[\\\"view 2\\\"][\\\"expected return\\\"] = 0.05\\n\\n# Active View 3\\n(\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_INFT\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_HLTH\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_REAL\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_STPL\\\"],\\n) = (0.5, 0.5, -0.5, -0.5)\\nQ.loc[\\\"view 3\\\"][\\\"expected return\\\"] = 0.3\\n\\n\\u03a9 = lambda \\u03c4, P, \\u03a3: np.diag(\\n    np.diag(\\u03c4 * ((P @ \\u03a3) @ P.T))\\n)  # 5. View uncertainty for each view portfolio equals the historical variance of each view portfolio\";\n",
       "                var nbb_formatted_code = \"\\u03b4_eq = lambda R_mkt, R_f, \\u03c3_mkt: (R_mkt - R_f) / (\\u03c3_mkt ** 2)  # Risk Aversion measure\\n\\u03a0 = lambda \\u03b4_eq, \\u03a3, w_eq: \\u03b4_eq * (\\u03a3 @ w_eq)  # Equilibrium Excess Return vector\\nC = lambda \\u03c4, \\u03a3: \\u03c4 * \\u03a3  # Covariance matrix for Prior Normal\\nH = lambda P, \\u03a9, C: (P.T @ np.linalg.inv(\\u03a9)) @ P + np.linalg.inv(\\n    C\\n)  # Precision Matrix of Posterior Normal\\n\\u03bd = lambda H, P, \\u03a9, Q, C, \\u03a0: np.linalg.inv(H) @ (\\n    (P.T @ np.linalg.inv(\\u03a9)) @ Q + np.linalg.inv(C) @ \\u03a0\\n)  # Mean of Posterior Normal\\n\\n\\u03bc = \\u03b3_pure_factor_monthly_returns[sector_factor.columns].mean()\\n\\u03a0 = \\u03bc  # 1. Arithmetic Historical average of monthly returns (N x 1)\\n\\u03a3 = \\u03b3_pure_factor_monthly_returns[\\n    sector_factor.columns\\n].cov()  # 2. Historical monthly covariance matrix (N x N)\\n\\u03c4 = 0.05  # 3. Uncertainty metric for prior distribution of \\u03b8's covariance matrix\\n\\nP = pd.DataFrame(\\n    np.zeros((3, len(sector_factor.columns))),\\n    index=[\\\"view 1\\\", \\\"view 2\\\", \\\"view 3\\\"],\\n    columns=sector_factor.columns,\\n)  # View Portfolio Matrix (k x N)\\nQ = pd.DataFrame(\\n    np.zeros((3, 1)), index=[\\\"view 1\\\", \\\"view 2\\\", \\\"view 3\\\"], columns=[\\\"expected return\\\"]\\n)  # View Expected Return Vector (k x 1)\\n\\n# Active View 1\\nP.loc[\\\"view 1\\\"][\\\"SECTOR_ENER\\\"] = 1\\nQ.loc[\\\"view 1\\\"][\\\"expected return\\\"] = 0.2\\n\\n# Active View 2\\nP.loc[\\\"view 2\\\"][\\\"SECTOR_FINA\\\"], P.loc[\\\"view 2\\\"][\\\"SECTOR_INDU\\\"] = 1, -1\\nQ.loc[\\\"view 2\\\"][\\\"expected return\\\"] = 0.05\\n\\n# Active View 3\\n(\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_INFT\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_HLTH\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_REAL\\\"],\\n    P.loc[\\\"view 3\\\"][\\\"SECTOR_STPL\\\"],\\n) = (0.5, 0.5, -0.5, -0.5)\\nQ.loc[\\\"view 3\\\"][\\\"expected return\\\"] = 0.3\\n\\n\\u03a9 = lambda \\u03c4, P, \\u03a3: np.diag(\\n    np.diag(\\u03c4 * ((P @ \\u03a3) @ P.T))\\n)  # 5. View uncertainty for each view portfolio equals the historical variance of each view portfolio\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "δ_eq = lambda R_mkt, R_f, σ_mkt: (R_mkt - R_f) / (σ_mkt ** 2)  # Risk Aversion measure\n",
    "Π = lambda δ_eq, Σ, w_eq: δ_eq * (Σ @ w_eq)  # Equilibrium Excess Return vector\n",
    "C = lambda τ, Σ: τ * Σ  # Covariance matrix for Prior Normal\n",
    "H = lambda P, Ω, C: (P.T @ np.linalg.inv(Ω)) @ P + np.linalg.inv(\n",
    "    C\n",
    ")  # Precision Matrix of Posterior Normal\n",
    "ν = lambda H, P, Ω, Q, C, Π: np.linalg.inv(H) @ (\n",
    "    (P.T @ np.linalg.inv(Ω)) @ Q + np.linalg.inv(C) @ Π\n",
    ")  # Mean of Posterior Normal\n",
    "\n",
    "μ = γ_pure_factor_monthly_returns[sector_factor.columns].mean()\n",
    "Π = μ  # 1. Arithmetic Historical average of monthly returns (N x 1)\n",
    "Σ = γ_pure_factor_monthly_returns[\n",
    "    sector_factor.columns\n",
    "].cov()  # 2. Historical monthly covariance matrix (N x N)\n",
    "τ = 0.05  # 3. Uncertainty metric for prior distribution of θ's covariance matrix\n",
    "\n",
    "P = pd.DataFrame(\n",
    "    np.zeros((3, len(sector_factor.columns))),\n",
    "    index=[\"view 1\", \"view 2\", \"view 3\"],\n",
    "    columns=sector_factor.columns,\n",
    ")  # View Portfolio Matrix (k x N)\n",
    "Q = pd.DataFrame(\n",
    "    np.zeros((3, 1)), index=[\"view 1\", \"view 2\", \"view 3\"], columns=[\"expected return\"]\n",
    ")  # View Expected Return Vector (k x 1)\n",
    "\n",
    "# Active View 1\n",
    "P.loc[\"view 1\"][\"SECTOR_ENER\"] = 1\n",
    "Q.loc[\"view 1\"][\"expected return\"] = 0.2\n",
    "\n",
    "# Active View 2\n",
    "P.loc[\"view 2\"][\"SECTOR_FINA\"], P.loc[\"view 2\"][\"SECTOR_INDU\"] = 1, -1\n",
    "Q.loc[\"view 2\"][\"expected return\"] = 0.05\n",
    "\n",
    "# Active View 3\n",
    "(\n",
    "    P.loc[\"view 3\"][\"SECTOR_INFT\"],\n",
    "    P.loc[\"view 3\"][\"SECTOR_HLTH\"],\n",
    "    P.loc[\"view 3\"][\"SECTOR_REAL\"],\n",
    "    P.loc[\"view 3\"][\"SECTOR_STPL\"],\n",
    ") = (0.5, 0.5, -0.5, -0.5)\n",
    "Q.loc[\"view 3\"][\"expected return\"] = 0.3\n",
    "\n",
    "Ω = lambda τ, P, Σ: np.diag(\n",
    "    np.diag(τ * ((P @ Σ) @ P.T))\n",
    ")  # 5. View uncertainty for each view portfolio equals the historical variance of each view portfolio"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### A. \n",
    "\n",
    "Without active views, given $\\Pi$ (from 1) and $\\Sigma$ (from 2), locate the optimal portfolio of the 10 sectors which has the highest expected return and at the same time its annualized volatility no greater than 10%. Note: this is an optimization problem with only one constraint on the total variance of the portfolio. Also notice that you need to transform the annualized vol to monthly vol. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Status: optimal\n",
      "The optimal value is: 0.68\n",
      "The optimal solution is: w = [0.23, 0.06, -0.64, 0.77, -0.28, 0.1, 0.44, 0.22, 0.02, -0.62]\n",
      "time: 15.3 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 7;\n",
       "                var nbb_unformatted_code = \"w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\\nconstraints = [\\n    cp.quad_form(w_eq, \\u03a3)\\n    <= (10 ** 2)\\n    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\\n]\\nobj = cp.Maximize(w_eq.T @ \\u03a0)\\nprob = cp.Problem(obj, constraints)\\nprob.solve()\\n\\nprint(f\\\"Status: {prob.status}\\\")\\nprint(f\\\"The optimal value is: {np.round(prob.value, 2)}\\\")\\nprint(f\\\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in w_eq.value]}\\\")\";\n",
       "                var nbb_formatted_code = \"w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\\nconstraints = [\\n    cp.quad_form(w_eq, \\u03a3)\\n    <= (10 ** 2)\\n    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\\n]\\nobj = cp.Maximize(w_eq.T @ \\u03a0)\\nprob = cp.Problem(obj, constraints)\\nprob.solve()\\n\\nprint(f\\\"Status: {prob.status}\\\")\\nprint(f\\\"The optimal value is: {np.round(prob.value, 2)}\\\")\\nprint(f\\\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in w_eq.value]}\\\")\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\n",
    "constraints = [\n",
    "    cp.quad_form(w_eq, Σ)\n",
    "    <= (10 ** 2)\n",
    "    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\n",
    "]\n",
    "obj = cp.Maximize(w_eq.T @ Π)\n",
    "prob = cp.Problem(obj, constraints)\n",
    "prob.solve()\n",
    "\n",
    "print(f\"Status: {prob.status}\")\n",
    "print(f\"The optimal value is: {np.round(prob.value, 2)}\")\n",
    "print(f\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in w_eq.value]}\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### B. \n",
    "\n",
    "Now let's incorporate the active views on 4 using Black-Litterman method,"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "1. show the updated factor expected return distribution and compare it with the original one, i.e., you need to calculate $\\nu$, which is the update return vector; and $(H^{-1}+\\Sigma)$, which is the updated covariance matrix. "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\\begin{align}\n",
    "    R\\vert Q \\sim \\mathcal{N}(\\nu, H^{-1} + \\Sigma)\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 4.24 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 8;\n",
       "                var nbb_unformatted_code = \"updated_factor_expected_return = \\u03bd(\\n    H(P=P.values, \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values), C=C(\\u03c4, \\u03a3.values)),\\n    P=P.values,\\n    \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values),\\n    Q=Q.values.flatten(),\\n    C=C(\\u03c4, \\u03a3.values),\\n    \\u03a0=\\u03a0.values,\\n)\\n\\nupdated_factor_covariance_matrix = (\\n    np.linalg.inv(H(P=P.values, \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values), C=C(\\u03c4, \\u03a3.values))) + \\u03a3\\n)\";\n",
       "                var nbb_formatted_code = \"updated_factor_expected_return = \\u03bd(\\n    H(P=P.values, \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values), C=C(\\u03c4, \\u03a3.values)),\\n    P=P.values,\\n    \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values),\\n    Q=Q.values.flatten(),\\n    C=C(\\u03c4, \\u03a3.values),\\n    \\u03a0=\\u03a0.values,\\n)\\n\\nupdated_factor_covariance_matrix = (\\n    np.linalg.inv(H(P=P.values, \\u03a9=\\u03a9(\\u03c4=\\u03c4, P=P.values, \\u03a3=\\u03a3.values), C=C(\\u03c4, \\u03a3.values))) + \\u03a3\\n)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "updated_factor_expected_return = ν(\n",
    "    H(P=P.values, Ω=Ω(τ=τ, P=P.values, Σ=Σ.values), C=C(τ, Σ.values)),\n",
    "    P=P.values,\n",
    "    Ω=Ω(τ=τ, P=P.values, Σ=Σ.values),\n",
    "    Q=Q.values.flatten(),\n",
    "    C=C(τ, Σ.values),\n",
    "    Π=Π.values,\n",
    ")\n",
    "\n",
    "updated_factor_covariance_matrix = (\n",
    "    np.linalg.inv(H(P=P.values, Ω=Ω(τ=τ, P=P.values, Σ=Σ.values), C=C(τ, Σ.values))) + Σ\n",
    ")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>original factor expected return</th>\n",
       "      <th>updated factor expected return</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>SECTOR_DSCR</th>\n",
       "      <td>0.18</td>\n",
       "      <td>0.22</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_ENER</th>\n",
       "      <td>0.07</td>\n",
       "      <td>0.16</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_FINA</th>\n",
       "      <td>-0.19</td>\n",
       "      <td>-0.01</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_HLTH</th>\n",
       "      <td>0.37</td>\n",
       "      <td>0.47</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_INDU</th>\n",
       "      <td>0.09</td>\n",
       "      <td>0.12</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_INFT</th>\n",
       "      <td>0.16</td>\n",
       "      <td>0.26</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_MATS</th>\n",
       "      <td>0.19</td>\n",
       "      <td>0.25</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_REAL</th>\n",
       "      <td>0.37</td>\n",
       "      <td>0.32</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_STPL</th>\n",
       "      <td>0.05</td>\n",
       "      <td>0.08</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_TCOM</th>\n",
       "      <td>-0.11</td>\n",
       "      <td>-0.03</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "             original factor expected return  updated factor expected return\n",
       "SECTOR_DSCR                             0.18                            0.22\n",
       "SECTOR_ENER                             0.07                            0.16\n",
       "SECTOR_FINA                            -0.19                           -0.01\n",
       "SECTOR_HLTH                             0.37                            0.47\n",
       "SECTOR_INDU                             0.09                            0.12\n",
       "SECTOR_INFT                             0.16                            0.26\n",
       "SECTOR_MATS                             0.19                            0.25\n",
       "SECTOR_REAL                             0.37                            0.32\n",
       "SECTOR_STPL                             0.05                            0.08\n",
       "SECTOR_TCOM                            -0.11                           -0.03"
      ]
     },
     "execution_count": 9,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 8.36 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 9;\n",
       "                var nbb_unformatted_code = \"\\u03a0.name = \\\"original factor expected return\\\"\\npd.concat(\\n    [\\n        np.round(\\u03a0, 2),\\n        pd.Series(\\n            np.round(updated_factor_expected_return, 2),\\n            index=\\u03a0.index,\\n            name=\\\"updated factor expected return\\\",\\n        ),\\n    ],\\n    axis=1,\\n)\";\n",
       "                var nbb_formatted_code = \"\\u03a0.name = \\\"original factor expected return\\\"\\npd.concat(\\n    [\\n        np.round(\\u03a0, 2),\\n        pd.Series(\\n            np.round(updated_factor_expected_return, 2),\\n            index=\\u03a0.index,\\n            name=\\\"updated factor expected return\\\",\\n        ),\\n    ],\\n    axis=1,\\n)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "Π.name = \"original factor expected return\"\n",
    "pd.concat(\n",
    "    [\n",
    "        np.round(Π, 2),\n",
    "        pd.Series(\n",
    "            np.round(updated_factor_expected_return, 2),\n",
    "            index=Π.index,\n",
    "            name=\"updated factor expected return\",\n",
    "        ),\n",
    "    ],\n",
    "    axis=1,\n",
    ")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "2. make observations on how active views impact updated returns."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Directly Affected Factors:\n",
    "\n",
    "- View 1: Sector ENER will have return of 0.20% in next month.\n",
    "    \n",
    "    - This absolute view has pushed up the original `SECTOR_ENER`'s monthly expected return from 0.07% to 0.16%.\n",
    "    \n",
    "- View 2: Sector FINA will outperform Sector INDU by 0.05% in next month.\n",
    "\n",
    "    - `SECTOR_FINA`'s monthly expected return has been pushed up from -0.19% to -0.01%.\n",
    "    \n",
    "    - However, the relative view pushed up `SECTOR_INDU`'s monthly expected return from 0.09% to 0.12% even though the relative view is bearish towards it\n",
    "    \n",
    "    - Although, `SECTOR_FINA`'s monthly expected return has increased more than `SECTOR_INDU`'s\n",
    "    \n",
    "- View 3: Sector INFT and Sector HLTH will outperform Sector REAL and Sector STPL by 0.30% in next month. (Assuming equal weighting on both long and short legs)\n",
    "\n",
    "    - This relative view has pushed up `SECTOR_HLTH`'s monthly expected return from 0.37% to 0.47% and `SECTOR_INFT` from 0.16% to 0.26%, while pushing down `SECTOR_REAL` from 0.37% to 0.32%\n",
    "    - However, `SECTOR_STPL`'s monthly expected return has increased from 0.05% to 0.08% even though the relative view was bearish on it."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Indirectly Affected Factors:\n",
    "\n",
    "- Because Black-Litterman accounts for how changes in one factor's expected return affects others through the covariance matrix:\n",
    "    - `SECTOR_DSCR` increased from 0.18% to 0.22%.\n",
    "    - `SECTOR_MATS`\tincreased from 0.19% to 0.25%.\n",
    "    - `SECTOR_TCOM`\tincreased from -0.11% to -0.03%."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "3. Re-run the optimization as in A, but with the new return vector and covariance matrix. Please compare the updated optimal portfolio (the weight vector) with the solution from A."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Status: optimal\n",
      "The optimal value is: 0.63\n",
      "The optimal solution is: w = [0.24, 0.07, -0.39, 0.89, -0.55, 0.2, 0.45, 0.12, -0.08, -0.64]\n",
      "time: 16.7 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 10;\n",
       "                var nbb_unformatted_code = \"updated_w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\\nconstraints = [\\n    cp.quad_form(updated_w_eq, updated_factor_covariance_matrix)\\n    <= (10 ** 2)\\n    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\\n]\\nobj = cp.Maximize(updated_w_eq.T @ updated_factor_expected_return)\\nprob = cp.Problem(obj, constraints)\\nprob.solve()\\n\\nprint(f\\\"Status: {prob.status}\\\")\\nprint(f\\\"The optimal value is: {np.round(prob.value, 2)}\\\")\\nprint(\\n    f\\\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in updated_w_eq.value]}\\\"\\n)\";\n",
       "                var nbb_formatted_code = \"updated_w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\\nconstraints = [\\n    cp.quad_form(updated_w_eq, updated_factor_covariance_matrix)\\n    <= (10 ** 2)\\n    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\\n]\\nobj = cp.Maximize(updated_w_eq.T @ updated_factor_expected_return)\\nprob = cp.Problem(obj, constraints)\\nprob.solve()\\n\\nprint(f\\\"Status: {prob.status}\\\")\\nprint(f\\\"The optimal value is: {np.round(prob.value, 2)}\\\")\\nprint(\\n    f\\\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in updated_w_eq.value]}\\\"\\n)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "updated_w_eq = cp.Variable((len(sector_factor.columns),), integer=False)\n",
    "constraints = [\n",
    "    cp.quad_form(updated_w_eq, updated_factor_covariance_matrix)\n",
    "    <= (10 ** 2)\n",
    "    / 12,  # (annualized volatility no greater than 10%)^2 / 12 => monthly variance\n",
    "]\n",
    "obj = cp.Maximize(updated_w_eq.T @ updated_factor_expected_return)\n",
    "prob = cp.Problem(obj, constraints)\n",
    "prob.solve()\n",
    "\n",
    "print(f\"Status: {prob.status}\")\n",
    "print(f\"The optimal value is: {np.round(prob.value, 2)}\")\n",
    "print(\n",
    "    f\"The optimal solution is: w = {[np.round(w_i, 2) for w_i in updated_w_eq.value]}\"\n",
    ")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>Original Optimal Portfolio Weights - A (%)</th>\n",
       "      <th>Updated Optimal Portfolio Weights - B (%)</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>SECTOR_DSCR</th>\n",
       "      <td>23.01</td>\n",
       "      <td>23.53</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_ENER</th>\n",
       "      <td>5.73</td>\n",
       "      <td>7.48</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_FINA</th>\n",
       "      <td>-63.93</td>\n",
       "      <td>-38.99</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_HLTH</th>\n",
       "      <td>77.41</td>\n",
       "      <td>89.05</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_INDU</th>\n",
       "      <td>-27.68</td>\n",
       "      <td>-54.70</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_INFT</th>\n",
       "      <td>9.83</td>\n",
       "      <td>19.94</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_MATS</th>\n",
       "      <td>43.70</td>\n",
       "      <td>44.69</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_REAL</th>\n",
       "      <td>21.60</td>\n",
       "      <td>12.21</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_STPL</th>\n",
       "      <td>1.78</td>\n",
       "      <td>-8.06</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>SECTOR_TCOM</th>\n",
       "      <td>-62.16</td>\n",
       "      <td>-63.57</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "             Original Optimal Portfolio Weights - A (%)  \\\n",
       "SECTOR_DSCR                                       23.01   \n",
       "SECTOR_ENER                                        5.73   \n",
       "SECTOR_FINA                                      -63.93   \n",
       "SECTOR_HLTH                                       77.41   \n",
       "SECTOR_INDU                                      -27.68   \n",
       "SECTOR_INFT                                        9.83   \n",
       "SECTOR_MATS                                       43.70   \n",
       "SECTOR_REAL                                       21.60   \n",
       "SECTOR_STPL                                        1.78   \n",
       "SECTOR_TCOM                                      -62.16   \n",
       "\n",
       "             Updated Optimal Portfolio Weights - B (%)  \n",
       "SECTOR_DSCR                                      23.53  \n",
       "SECTOR_ENER                                       7.48  \n",
       "SECTOR_FINA                                     -38.99  \n",
       "SECTOR_HLTH                                      89.05  \n",
       "SECTOR_INDU                                     -54.70  \n",
       "SECTOR_INFT                                      19.94  \n",
       "SECTOR_MATS                                      44.69  \n",
       "SECTOR_REAL                                      12.21  \n",
       "SECTOR_STPL                                      -8.06  \n",
       "SECTOR_TCOM                                     -63.57  "
      ]
     },
     "execution_count": 11,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 10 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 11;\n",
       "                var nbb_unformatted_code = \"pd.DataFrame(\\n    np.round(np.array([w_eq.value, updated_w_eq.value]).T, 4) * 100,\\n    index=sector_factor.columns,\\n    columns=[\\n        \\\"Original Optimal Portfolio Weights - A (%)\\\",\\n        \\\"Updated Optimal Portfolio Weights - B (%)\\\",\\n    ],\\n)\";\n",
       "                var nbb_formatted_code = \"pd.DataFrame(\\n    np.round(np.array([w_eq.value, updated_w_eq.value]).T, 4) * 100,\\n    index=sector_factor.columns,\\n    columns=[\\n        \\\"Original Optimal Portfolio Weights - A (%)\\\",\\n        \\\"Updated Optimal Portfolio Weights - B (%)\\\",\\n    ],\\n)\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "pd.DataFrame(\n",
    "    np.round(np.array([w_eq.value, updated_w_eq.value]).T, 4) * 100,\n",
    "    index=sector_factor.columns,\n",
    "    columns=[\n",
    "        \"Original Optimal Portfolio Weights - A (%)\",\n",
    "        \"Updated Optimal Portfolio Weights - B (%)\",\n",
    "    ],\n",
    ")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Directly Affected Factors:\n",
    "\n",
    "- View 1: Sector ENER will have return of 0.20% in next month.\n",
    "    \n",
    "    - The position has become longer, as expected, from 5.73% to 7.48 %.\n",
    "    \n",
    "- View 2: Sector FINA will outperform Sector INDU by 0.05% in next month.\n",
    "\n",
    "    - `SECTOR_FINA` position has become longer, as expected, from -63.93% to -38.99%.\n",
    "    - `SECTOR_INDU` position has become shorter, as expected, from -27.68% to --54.70%.\n",
    "    \n",
    "- View 3: Sector INFT and Sector HLTH will outperform Sector REAL and Sector STPL by 0.30% in next month. (Assuming equal weighting on both long and short legs)\n",
    "\n",
    "    - `SECTOR_INFT` position has become longer, as expected, from 9.83% to 19.94%.\n",
    "    - `SECTOR_HLTH` position has become longer, as expected, from 77.41% to 89.05%.\n",
    "    - `SECTOR_REAL` position has become shorter, as expected, from 21.60% to 12.21%.\n",
    "    - `SECTOR_STPL` position has become shorter, as expected, from 1.78% to -8.06%."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Indirectly Affected Factors:\n",
    "\n",
    "- Because Black-Litterman accounts for how changes in one factor's expected return affects others through the covariance matrix, some of the portfolio allocations of other factors not directly related to our active views also change:\n",
    "\n",
    "    - `SECTOR_DSCR` position became slightly longer, from 23.01% to 23.53%.\n",
    "    - `SECTOR_MATS` position became slightly longer, from 43.70% to 44.69%.\n",
    "    - `SECTOR_TCOM` position became slightly shorter, from -62.16% to -63.57%."
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.5"
  },
  "latex_envs": {
   "LaTeX_envs_menu_present": true,
   "autoclose": false,
   "autocomplete": true,
   "bibliofile": "biblio.bib",
   "cite_by": "apalike",
   "current_citInitial": 1,
   "eqLabelWithNumbers": true,
   "eqNumInitial": 1,
   "hotkeys": {
    "equation": "Ctrl-E",
    "itemize": "Ctrl-I"
   },
   "labels_anchors": false,
   "latex_user_defs": false,
   "report_style_numbering": false,
   "user_envs_cfg": false
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
